Description
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also a prime. You
will just have to paste four new digits over the four old ones on your
office door.
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from 1033 to 8179 by a
path of prime numbers where only one digit is changed from one prime to
the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going
on... Help the prime minister to find the cheapest prime path between
any two given four-digit primes! The first digit must be nonzero, of
course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The
cost of this solution is 6 pounds. Note that the digit 1 which got
pasted over in step 2 can not be reused in the last step – a new 1 must
be purchased.
#include<iostream>
#include<cstring>
#include<queue> using namespace std; bool rem[];
int rans[]; void getPrime()
{
for(int i=;i<;++i)
if(rem[i]==)
for(int j=i*;j<;j+=i)
rem[j]=;
} int bfs(int S,int E)
{
memset(rans,-,sizeof(rans)); queue<int> que;
int t;
int temp; que.push(S);
rans[S]=; while(!que.empty())
{
t=que.front();
que.pop(); if(t==E)
return rans[E]; for(int i=;i<=;++i)
{
temp=t%+i*;
if(rans[temp]==-&&rem[temp]==)
{
rans[temp]=rans[t]+;
que.push(temp);
}
}
for(int i=;i<=;++i)
{
temp=t%+*i+(t/)*;
if(rans[temp]==-&&rem[temp]==)
{
rans[temp]=rans[t]+;
que.push(temp);
}
}
for(int i=;i<=;++i)
{
temp=t%+*i+(t/)*;
if(rans[temp]==-&&rem[temp]==)
{
rans[temp]=rans[t]+;
que.push(temp);
}
}
for(int i=;i<=;++i)
{
temp=(t/)*+i;
if(rans[temp]==-&&rem[temp]==)
{
rans[temp]=rans[t]+;
que.push(temp);
}
}
} return -;
} int main()
{
ios::sync_with_stdio(false); getPrime(); int T;
int a,b;
int ans; cin>>T; while(T--)
{
cin>>a>>b; ans=bfs(a,b); if(ans==-)
cout<<"Impossible\n";
else
cout<<ans<<endl;
} return ;
}